form(nz-form, [formGroup]="form", nzLayout="vertical", (ngSubmit)="onSubmit()")
  ng-container()
    nz-form-item
      nz-form-label(nzFor="name", [nzRequired]="true")
        span
          | Repository name
          i.ml1(nz-icon, nz-tooltip, [nzTooltipTitle]="nameHelpTemplate", nzType="question-circle", theme="outline")
      nz-form-control(nzHasFeedback, [nzErrorTip]="nameErrorTemplate")
        input(nz-input, id="name", formControlName="name", placeholder="Enter repository name")

    nz-form-item
      nz-form-label(nzFor="url", [nzRequired]="true")
        span
          | Repository url
          i.ml1(nz-icon, nz-tooltip, [nzTooltipTitle]="urlHelpTemplate", nzType="question-circle", theme="outline")
      nz-form-control(nzHasFeedback, [nzErrorTip]="urlErrorTemplate")
        input(nz-input, id="url", formControlName="url", placeholder="Enter repository url")

    nz-form-item
      nz-form-label(nzFor="username")
        span
          | Username
          i.ml1(nz-icon, nz-tooltip, [nzTooltipTitle]="usernameHelpTemplate", nzType="question-circle", theme="outline")
      nz-form-control(nzHasFeedback, [nzErrorTip]="usernameErrorTemplate")
        input(nz-input, id="username", formControlName="username", placeholder="Enter username")

    nz-form-item
      nz-form-label(nzFor="password")
        span
          | Password
          i.ml1(nz-icon, nz-tooltip, [nzTooltipTitle]="passwordHelpTemplate", nzType="question-circle", theme="outline")
      nz-form-control(nzHasFeedback, [nzErrorTip]="passwordErrorTemplate")
        ng-container(*ngIf="!isPasswordSet")
          input(nz-input, type="password", id="password", formControlName="password", placeholder="Enter password")
        ng-container(*ngIf="isPasswordSet")
          input(nz-input, type="password", id="password", formControlName="password")


  nz-form-item.right
    nz-form-control
      button(nz-button, nzType="primary", type="submit", [disabled]="form.invalid") Save

ng-template(#nameHelpTemplate)
  ng-container Specify the repository name

ng-template(#urlHelpTemplate)
  ng-container Specify the repository url, it should be the url used to clone the repository, generally ending by ".git"

ng-template(#usernameHelpTemplate)
  ng-container Specify your git username. Username account to use to connect to git repository. This field is required for non-public repository

ng-template(#passwordHelpTemplate)
  ng-container Specify your git password. Password account to use to connect to git repository. This field is required for non-public repository


ng-template(#nameErrorTemplate, let-control)
  ng-container(*ngIf="control.hasError('required')") Repository name is required

ng-template(#urlErrorTemplate, let-control)
  ng-container(*ngIf="control.hasError('required')") Repository url is required

ng-template(#usernameErrorTemplate, let-control)
  ng-container(*ngIf="control.hasError('required')") Git username is required, only if the repository isn't public

ng-template(#passwordErrorTemplate, let-control)
  ng-container(*ngIf="control.hasError('required')") Git password is required, only if the repository isn't public
